<template>
	<div v-show="bank_account && start_date && end_date">
		<BankReconciliationChart
			ref="reconciliationChart"
			:bank_account="bank_account"
			:start_date="start_date"
			:end_date="end_date"
		/>
		<BankReconciliationInfo
			:bank_account="bank_account"
			:start_date="start_date"
			:end_date="end_date"
		/>
		<BankReconciliationActions
			:selected_transactions="selectedTransactions"
			:selected_documents="selectedDocuments"
			@resetList="reset_list"
		/>
		<div class="row reconciliation-dashboard">
			<div class="col-md-6">
				<BankReconciliationTransactionList
					ref="transactionsList"
					:bank_account="bank_account"
					:start_date="start_date"
					:end_date="end_date"
					:selected_transactions="selectedTransactions"
					@transactionsChange="transactions_change"
				/>
			</div>
			 <div class="col-md-6">
				<BankReconciliationMatchingBox
					:transactions="selectedTransactions"
					@documentsChange="documents_change"
				/>
			</div>
		</div>
	</div>
</template>

<script setup>
import { ref, computed} from 'vue'

import BankReconciliationChart from './BankReconciliationChart.vue';
import BankReconciliationTransactionList from './BankReconciliationTransactionList.vue';
import BankReconciliationInfo from './BankReconciliationInfo.vue';
import BankReconciliationMatchingBox from './BankReconciliationMatchingBox.vue';
import BankReconciliationActions from './BankReconciliationActions.vue';

const props = defineProps({
	bank_account: {
		type: String,
		default: null
	},
	date_range: {
		type: Array,
		default: () => []
	}
})

const bank_account = ref(props.bank_account)
const date_range = ref(props.date_range)
const transactionsList = ref(null)
const reconciliationChart = ref(null)
const selectedTransactions = ref([])
const selectedDocuments = ref([])

const start_date = computed(() => {
	return date_range.value[0]
})

const end_date = computed(() => {
	return date_range.value[1]
})

erpnext.bank_reconciliation.on('filter_change', data => {
	switch (data.name) {
		case 'BANK_ACCOUNT':
			bank_account.value = data.value;
			break;
		case 'DATE_RANGE':
			date_range.value = data.value;
			break;
	}
})

erpnext.bank_reconciliation.on('refresh', () => {
	reset_list()
})

function transactions_change(selection) {
	selectedTransactions.value = selection;
	check_selected_rows()
}

function documents_change(selection) {
	selectedDocuments.value = selection;
	check_selected_rows()
}

function check_selected_rows() {
	if (selectedTransactions.length > 1 && selectedDocuments.length > 1) {
		frappe.msgprint(__("Please select only one bank transaction and multiple documents or multiple bank transactions and only one document."))
	}
}

function reset_list() {
	transactionsList.value.get_transaction_list();
	reconciliationChart.value.getChartData();
}
</script>

<style lang="scss">
.reconciliation-dashboard {
	margin-top: 30px;
}

.reconciliation-btn {
	margin: 20px 0;
}

.reconciliation-dashboard {
	.tabulator-col-content:has(.tabulator-header-filter) {
		padding: 1px !important;
	}
	.tabulator-header-filter {
		input {
			appearance: none;
			border-radius: 99px;
			border: 1px solid var(--border-color);
			font-weight: var(--weight-bold);
			padding: 1px 8px !important;
			text-align: initial;
		}
		&:not(:focus-within,:hover)::after {
			display: block;
			background-image: url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 500 500"><g transform="translate(-4 -560)"><path d="M233 615A154 154 0 0 0 79 769a154 154 0 0 0 154 154 154 154 0 0 0 154-154 154 154 0 0 0-154-154Zm0 27a130 127 0 0 1 130 127 130 127 0 0 1-130 127 130 127 0 0 1-130-127 130 127 0 0 1 130-127Z"/><rect width="173" height="36.2" x="795" y="320" rx="33.2" ry="18.1" transform="rotate(49) skewX(12)"/></g></svg>');
			background-repeat: no-repeat;
			background-position: right center;
			width: 1em;
			position: absolute;
			content: "";
			top: 0;
			bottom: 0;
			right: 6px;
			pointer-events: none;
		}
	}
}
</style>
